import { DomainEvent } from './index';
export interface CoreEvents {
    AggregateDeleted: {
        types: string[];
    };
}
declare type PossiblyDomainEvent<T extends Record<string, any>, K extends keyof Pick<T, string>> = unknown extends T[K] ? never : DomainEvent<T[K]>;
export declare function handle<T extends Record<string, any>, K extends keyof Pick<T, string>>(name: K, handler: (ev: PossiblyDomainEvent<T, K>) => void | Promise<any>): (id: string, data: T[K]) => void | Promise<any>;
export declare function emit(name: string, ev: DomainEvent): void;
export declare function emitImmediate<T extends Record<string, any>, K extends keyof Pick<T, string>>(id: string, name: K, data: unknown extends T[K] ? never : T[K]): void;
export {};
